/*	
 *	cliprend.h
 *
 *	`惉Cu`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Feb 13 06:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_REND_H__
#define __CLIP_REND_H__

/*****************************************************************************
 *	
 *****************************************************************************/

#ifdef PIECE
typedef PBMP_FILEHEADER	TEXTUREHEADER;
typedef PIECE_BMP	TEXTURE;
#else /*PIECE*/
typedef struct _TEXTUREHEADER {		/* PBMP_FILEHEADERɃoCi݊ */
	unsigned long head;		/* + 0,4 VOl`'PBMP'        */
	unsigned long fsize;		/* + 4,4 t@CTCY          */
	unsigned char bpp;		/* + 8,1 rbg[x              */
	unsigned char mask;		/* + 9,1 }XN[x              */
	short w;			/* +10,2                       */
	short h;			/* +12,2                     */
					/* +14,2 pfBO              */
	unsigned long buf_size;		/* +16,4 f[^TCY            */
					/* =20                           */
} TEXTUREHEADER;
typedef struct _TEXTURE {		/* PIECE_BMPɃoCi݊ */
	TEXTUREHEADER header;		/* + 0,20 wb_           */
	unsigned char* buf;		/* +20, 4 rbgf[^     */
	unsigned char* mask;		/* +24, 4 }XNf[^     */
					/* =28                     */
} TEXTURE;
#endif /*PIECE*/

typedef struct _SURFACE {		/* `T[tFCX   */
	short w;			/* + 0,2              */
	short h;			/* + 2,2            */
	unsigned char* vbuff;		/* + 4,4 J[obt@ */
	unsigned char* zbuff;		/* + 8,4 yobt@     */
					/* =12                  */
} SURFACE;

typedef struct _VERTEX {		/* |S_          */
	short x;			/* +0,2 sNZW */
	short y;			/* +2,2 sNZW */
	unsigned char s;		/* +4,1 eNZW */
	unsigned char t;		/* +5,1 eNZW */
} VERTEX;				/* =6                    */

typedef struct _TCOORD {		/* eNX`W */
	unsigned char s;		/* +0,1 W  */
	unsigned char t;		/* +1,1 W  */
					/* =2             */
} TCOORD;

typedef struct _FACEVERTEX {		/* tFCX_                  */
	unsigned char iv;		/* +0,1 _WCfNX       */
	unsigned char ic;		/* +1,1 eNX`WCfNX */
} FACEVERTEX;

typedef struct _FACE {			/* tFCX                      */
	unsigned char nfv;		/* +0,1    _̐              */
	unsigned char c;		/* +1,1    J[                */
	/*FACEVERTEX fv[nfv];*/		/* +2,2nfv tFCX_Xg    */
					/* =2+2nfv                       */
} FACE;

typedef struct _MESH {			/* bV                             */
	unsigned char nv;		/* +0,1            _W̐         */
	unsigned char nc;		/* +1,1            eNX`W̐   */
	unsigned char nf;		/* +2,1            tFCX̐         */
	unsigned char reserved;		/* +3,1            (\)               */
	/*VECTOR v[nv];*/		/* +4,12nv         _WXg       */
	/*TCOORD c[nc];*/		/* +4+12nv,2nc     eNX`WXg */
	/*FACE f[nf];*/			/* +4+12nv+2nc,(?) tFCXXg       */
					/* =4+12nv+2nc+(?)                      */
} MESH;

/* eNX`\̂܂B
 * [in]
 *	texture		eNX`\́B
 *	data		PBMPt@CC[W̐擪AhXB
 * [out]
 *	߂l		texture̒l̂܂ܕԂ܂B
 * [note]
 *	* TEXTURE\̂PIECE_BMP\̂Ɠ(typedef)Ȃ̂ŁA
 *	  ̊֐PIECE_BMP\̂̏ɂpł܂B
 */
TEXTURE* texture_init(TEXTURE* texture, const void* data);

/* T[tFCXNA܂B
 * [in]
 *	surface		T[tFCX\́B
 *	color		wiFB
 * [note]
 *	* J[obt@(vbuff)NULLłȂ΁AwiFŃNA܂B
 *	* yobt@(zbuff)NULLłȂ΁A0xFFŃNA܂B
 */
void surface_clear(SURFACE* surface, int color);

/* sNZJ[擾܂B
 * [in]
 *	surface		T[tFCX\́B
 *	x,y		sNZWB
 * [out]
 *	߂l		sNZJ[B
 *			T[tFCXÕsNZWȂA-1Ԃ܂B
 * [note]
 *	* ̊֐́Arender_point()Ƒ΂𐬂܂B
 */
int surface_point(SURFACE* surface, int x, int y);

/*****************************************************************************
 *	RENDER
 *****************************************************************************/

#define RENDER_CONTEXT_STACK_SIZE	16			/* ReLXgX^bNTCY */

typedef struct _RENDERCONTEXT {
	MATRIX matrix;						/* ϊs               */
	TEXTURE* texture;					/* eNX`(NULL:Ȃ)  */
} RENDERCONTEXT;

typedef struct _RENDER {
	SURFACE* surface;					/* `T[tFCX                 */
	short left, top, right, bottom;				/* r[|[g`(ObhWn) */
	float front, back;					/* NbsO                 */
	RENDERCONTEXT* context;					/* ReLXgX^bNgbv       */
	RENDERCONTEXT context_stack[RENDER_CONTEXT_STACK_SIZE];	/* ReLXgX^bN             */
} RENDER;

/* t[܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	surface		`T[tFCXB
 *	x,y		r[|[g_B
 *	width,height	r[|[gTCYB
 *	front,back	NbsOB
 *	fovy		pxB
 * [note]
 *	* width,height0w肷ƁAT[tFCX̕AƓƌȂ܂B
 *	  ]āAT[tFCXŜr[|[g̈ƂĎw肷ɂ́A
 *	  x,y,width,height0,0,0,0Ǝw肷̂ȒPłB
 *	* Rc`sȂꍇ́Afront,back,fovy̎w͓KȒlō\܂B
 *	  front,back.fovy0,0,0Ǝw肷̂ȒPłB
 *	* ̊֐́AT[tFCX̃NAs܂B
 *	  J[obt@тyobt@̃NÁAĂяoōsĂB
 */
void render_init(RENDER* render, SURFACE* surface, int x, int y, int width, int height, float front, float back, float fovy);

/* ReLXgޔ܂B
 * [in]
 *	render		_[ւ̃|C^B
 */
void render_save(RENDER* render);

/* ReLXg𕜌܂B
 * [in]
 *	render		_[ւ̃|C^B
 */
void render_restore(RENDER* render);

/* _`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x,y		_̍WB
 *	color		J[B
 * [note]
 *	* ̊֐́Asurface_point()Ƒ΂𐬂܂B
 */
void render_point(RENDER* render, int x, int y, int color);

/* F͈̔͂hԂ܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x0,y0		hԂJn_B
 *	color		J[B
 * [out]
 *	߂l		hsNZ̐B
 * [note]
 *	* (x0,y0)̐F͈͂AcolorœhԂ܂B
 *	  (x0,y0)̐FcolorƓȂA܂B
 *	* (x0,y0)r[|[gOȂA܂B
 */
int render_paint(RENDER* render, int x0, int y0, int color);

/* `܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x0,y0		n_WB
 *	x1,y1		I_WB
 *	color		J[B
 * [note]
 *	* p``߂ɁAAČĂяo邱Ƃz肵Ă܂B
 *	  āAI_sNZ(x1,y1)͕`܂B
 *	* ̓sANbsOꂽ̏I_`Ȃ̂ŁA
 *	  ʓʊOւ̐`ƂƁAʒ[1sNZ
 *	  ԂłĂ܂܂BvCB
 *	* Fri Mar  8 07:00:00 JST 2002 Naoyuki Sawa
 *	  C܂B
 */
void render_line(RENDER* render, int x0, int y0, int x1, int y1, int color);

/* j`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x0,y0		n_WB
 *	x1,y1		I_WB
 *	i_pat		jp^[̊JnCfbNXB
 *	pat		jp^[B(J[l̔zBl4ȏ͓)
 *	n_pat		jp^[̗vfB(1ȏ)
 * [note]
 *	* n_pat0w肷ƁA[ZG[܂B
 *	* i_pat>=n_patł\܂BK؂ȌJԂʒuJn܂B
 */
void render_dashes(RENDER* render, int x0, int y0, int x1, int y1, unsigned i_pat, const unsigned char* pat, unsigned n_pat);

/* ``܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x,y		㌴_WB
 *	w,h		`̃TCYB
 *	color		J[B
 */
void render_rectangle(RENDER* render, int x, int y, int w, int h, int color);

/* `hԂ܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x,y		㌴_WB
 *	w,h		`̃TCYB
 *	color		J[B
 */
void render_rectangle_fill(RENDER* render, int x, int y, int w, int h, int color);

/* |S`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	vertices	_XgB
 *	n_vertices	_̐B
 *	color		J[B
 */
void render_polygon(RENDER* render, const VERTEX* vertices, int n_vertices, int color);

/* bV`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	mesh		`悳郁bVB
 */
void render_mesh(RENDER* render, const MESH* mesh);

#endif /*__CLIP_REND_H__*/
