/*
 *	main.c
 *
 *	\eBAwN_CNx
 *
 *	* Tue Sep 22 08:28:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

extern unsigned char PAT[];
extern unsigned char BG[];
#include "snd/s1.c"
#include "snd/s2.c"
#include "snd/s3.c"
#include "snd/s4.c"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/* J[hCfbNX
 *	00-0c	Xy[h``j
 *	10-1c	_C@``j
 *	20-2c	Nu@``j
 *	30-3c	n[g@``j
 */
#define CARD_MARK(c)		(((c) >> 4) & 0xf)
#define CARD_NO(c)		(((c) >> 0) & 0xf)
#define CARD_MAKE(m, n)		(((m) & 0xf) << 4 | ((n) & 0xf) << 0)
#define CARD_REV		0x41	/* (\p) */
#define CARD_NUL		0x42	/* (\p) */
#define CARD_NORMAL		0x4b	/* ʏwi(\p) */
#define CARD_SELECT		0x4c	/* Iwi(\p) */

/* ICfbNX
 * TYPE=SEL_YAMA_FUSE
 *	COL=(g܂)
 *	ROW=(g܂)
 * TYPE=SEL_YAMA_HIRA
 *	COL=(g܂)
 *	ROW=(g܂)
 * TYPE=SEL_BA
 *	COL=0-6  D̗I
 *	ROW=0-51 D̍sI (̏ꍇ͎g܂)
 * TYPE=SEL_KUMI
 *	COL=0-3 gD̗I
 *	ROW=(g܂)
 */
#define SEL_YAMA_FUSE		0
#define SEL_YAMA_HIRA		1
#define SEL_BA			2
#define SEL_KUMI		3
#define SEL_TYPE(s)		(((s) >> 24) & 0xff)
#define SEL_COL(s)		(((s) >>  8) & 0xff)
#define SEL_ROW(s)		(((s) >>  0) & 0xff)
#define SEL_MAKE(t, c, r)	(((t) & 0xff) << 24 | ((c) & 0xff) << 8 | ((r) & 0xff) << 0)

typedef struct _SEL {
	int src;	/* ړ */
	int dst[52];	/* ړ惊Xg */
	int n_dst;	/* ړ̐ */
	int i_dst;	/* ړI */
} SEL;

typedef struct _GAMEINFO {
	int time;			/* oߎ */
	int gameover;			/* Q[I[o[(s)tO */
	/* J[h */
	unsigned char yama_fuse[52];	/* RD() */
	int n_yama_fuse;		/* RD()̐ */
	unsigned char yama_hira[52];	/* RD(J) */
	int n_yama_hira;		/* RD(J)̐ */
	unsigned char yama_naga[52];	/* RD() */
	int n_yama_naga;		/* RD()̐ */
	unsigned char ba[7][52];	/* D */
	int n_ba[7];			/* D̐ */
	int n_ba_fuse[7];		/* D()̐ */
	unsigned char kumi[4][13];	/* gD */
	int n_kumi[4];			/* gD̐ */
	/* I */
	SEL sel[52];			/* ړXg */
	int n_sel;			/* ړ̐   */
	int i_sel;			/* ړI   */
	/* \ */
	int top;			/* \[C */
	int bottom;			/* `扺[C */
} GAMEINFO;

/* KChp^[ */
unsigned char dashes[] = { 1, 2, 3, 4, 4 };

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

PIECE_BMP pat, bg;			/* rbg}bv */

int best_time = SEC(100 * 60 * 60) - 1;	/* xXg^C */
GAMEINFO gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void game_init();
void sound(int no);
void stredge(int x, int y, const char* str, int outcol, int incol);
void timestr(char* str, int time);
void card_disp(int x, int y, unsigned char card, int sel);
void field_disp();
int find_sel(SEL sel[52]);
int find_dst(int src, int dst[52]);
void do_move(int src, int dst);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	gi.gameover = 1; /* ^Cgł1P^C\}̂ */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* rbg}bvB */
	texture_init(&pat, PAT);
	texture_init(&bg, BG);

	/* TEh{[őɁB */
	pceWaveSetChAtt(0, 0);

	/* B */
	srand(pceTimerGetCount());
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mɃTEh~܂B */
	pceWaveStop(0);
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5)		/* PAUSEbZ[W̉ */
#define PAUSE_H		10		/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	unsigned char save[PAUSE_H][PAUSE_W];

	pause = 0;
	for(;;) {
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */

		/* PAUSEB */
		if(joy & TRG_START) {
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
		if(!(pause & 1)) break;

		/* PAUSEbZ[W_ŕ\B */
		pceFontSetType(PAUSE_FONT);
		pceFontSetTxColor(pause & 2 ? 2 : 3);
		pceFontSetBkColor(pause & 2 ? 0 : 1);
		pceFontSetPos(PAUSE_X, PAUSE_Y);
		pceFontPutStr(PAUSE_STR);
		pause ^= 2;
	}
	now++;	/* O[o^C}XV */

#undef PAUSE_FONT
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	unsigned char* p, c;
	char str[32];
	int x, y;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_SELECT) return -1;
		if(joy & TRG_A     ) return 0;

		/* ʃNAB */
		p = vbuff;
		c = 1;
		for(y = 0; y < DISP_Y; y++, c ^= 1) {
			for(x = 0; x < DISP_X; x++, c ^= 1) {
				*p++ = c;
			}
		}

		/* ^Cg\B */
		pceFontSetBkColor(-1);
		pceFontSetType(0x80);
		strcpy(str, "\eBA");
		x = (DISP_X - 5 * strlen(str)) / 2;
		y = 27;
		stredge(x, y, str, 3, 1);
		pceFontSetType(0x81);
		strcpy(str, "KLONDIKE");
		x = (DISP_X - 8 * strlen(str)) / 2 + 1;
		y = 38;
		stredge(x, y, str, 3, 2);

		/* XRA\B */
		pceFontSetType(0x82);
		x = (DISP_X - 4 * 8) / 2;
		y = 2;
		strcpy(str, "BESTTIME");
		stredge(x, y, str, 3, 0);
		y += 8;
		timestr(str, best_time);
		stredge(x, y, str, 3, 0);
		if(!gi.gameover) { /* ÕQ[ꍇ̂1P^C\ */
			timestr(str, gi.time);
			x = (DISP_X - 4 * 8) / 2;
			y = DISP_Y - 6;
			stredge(x, y, str, 3, 0);
		}

		/* vvg\B */
		if(now % SEC(1.0) < SEC(0.67)) {
			pceFontSetType(0x82);
			strcpy(str, " A  START");
			x = (DISP_X - 4 * strlen(str)) / 2;
			y = DISP_Y - 28;
			stredge(x, y, str, 3, 0);
			strcpy(str, "SEL EXIT");
			x = (DISP_X - 4 * strlen(str)) / 2;
			y += 8;
			stredge(x, y, str, 3, 0);
		}
	}

	return 0; /* _~[ */
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int i, x, y;
	const char* str;

	game_init();

	sound(2);
	for(;;) {
		schedule();
		gi.time++;

		/* f */
		if(joy & TRG_SELECT) {
			gi.gameover = 1;
			break;
		}

		/* ړIύX */
		if(joy & TRG_LF) {
			if(gi.n_sel > 1) {
				sound(3);
				if(--gi.i_sel == -1)
				     gi.i_sel = gi.n_sel - 1;
			} else {
				sound(1);
			}
		} else if(joy & TRG_RI) {
			if(gi.n_sel > 1) {
				sound(3);
				if(++gi.i_sel == gi.n_sel)
				     gi.i_sel = 0;
			} else {
				sound(1);
			}
		/* ړIύX */
		} else if(joy & TRG_UP) {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				sound(3);
				if(--gi.sel[gi.i_sel].i_dst == -1)
				     gi.sel[gi.i_sel].i_dst = gi.sel[gi.i_sel].n_dst - 1;
			} else {
				sound(1);
			}
		} else if(joy & TRG_DN) {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				sound(3);
				if(++gi.sel[gi.i_sel].i_dst == gi.sel[gi.i_sel].n_dst)
				     gi.sel[gi.i_sel].i_dst = 0;
			} else {
				sound(1);
			}
		/* ړs */
		} else if(joy & TRG_A) {
			sound(0);
			do_move(gi.sel[gi.i_sel].src,
			        gi.sel[gi.i_sel].dst[gi.sel[gi.i_sel].i_dst]);
			/* NAB */
			for(i = 0; i < 4; i++) if(gi.n_kumi[i] != 13) break;
			if(i == 4) break; /* CLEAR */
			/* ̈ړEړIB */
			gi.n_sel = find_sel(gi.sel);
			if(gi.n_sel == 0) { /* IȂAGAMEOVER */
				gi.gameover = 1;
				break;
			}
			gi.i_sel = 0;
		}

		/* ʕ\B */
		field_disp();
	}
	sound(2);

	/* BR}hFNA */
	if((joy & (PAD_UP | PAD_DN | PAD_LF | PAD_RI))
	       == (PAD_UP | PAD_DN | PAD_LF | PAD_RI)) gi.gameover = 0;

	/* IbZ[W\B */
	gi.n_sel = 0; /* I\}̂ */
	field_disp();
	if(gi.gameover) {
		str = "GAME OVER";
	} else {
		if(gi.time < best_time) {
			best_time = gi.time;
			str = "BEST TIME";
		} else {
			str = "CLEAR";
		}
	}
	x = (DISP_X - strlen(str) * 8) / 2;
	y = (DISP_Y - 10) / 2;
	pceFontSetType(0x81);
	stredge(x, y, str, 0, 3);
	for(i = 0; i < SEC(3); i++) {
		schedule();
		if(joy & TRG_MASK) break;
	}
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	int i, j, mark, no;
	unsigned char cards[52];

	memset(&gi, 0, sizeof gi);

	/* ܂Xy[h``n[gj܂ł̕т܂B */
	i = 0;
	for(mark = 0; mark < 4; mark++) {
		for(no = 0; no < 13; no++) {
			cards[i++] = CARD_MAKE(mark, no);
		}
	}

	/* VbtĎRDɒu܂B */
	for(i = 52; i > 0; i--) {	/* i=c薇 */
		j = rand() % i;		/* j=ڂo */
		gi.yama_fuse[gi.n_yama_fuse++] = cards[j]; /* oĎRDֈړ */
		cards[j] = cards[i - 1];/* oƂɍŌ̃J[hړ */
	}

	/* D܂B */
	for(i = 0; i < 7; i++) {
		for(j = 0; j < i + 1; j++) {	/* iɂi+1̃J[hu */
			gi.ba[i][gi.n_ba[i]++] = gi.yama_fuse[--gi.n_yama_fuse];
		}
		gi.n_ba_fuse[i] = i;		/* ̂i͕Ă */
	}

	/* ŏ̈ړEړIB */
	gi.n_sel = find_sel(gi.sel);
	gi.i_sel = 0;
}

/****************************************************************************
 *	sound
 ****************************************************************************/

void
sound(int no)
{
	static PCEWAVEINFO wi;
	const unsigned char* p;

	pceWaveAbort(0);
	switch(no) {
	case 0: p = S1; break;
	case 1: p = S2; break;
	case 2: p = S3; break;
	case 3: p = S4; break;
	default: return;
	}
	memcpy(&wi, p + 8, sizeof(PCEWAVEINFO));
	wi.pData = p + 8 + sizeof(PCEWAVEINFO);
	pceWaveDataOut(0, &wi);
}

/****************************************************************************
 *	stredge
 ****************************************************************************/

void
stredge(int x, int y, const char* str, int outcol, int incol)
{
	pceFontSetBkColor(-1);
	pceFontSetTxColor(outcol);
	pceFontSetPos(x    , y - 1); pceFontPutStr(str);
	pceFontSetPos(x - 1, y    ); pceFontPutStr(str);
	pceFontSetPos(x + 1, y    ); pceFontPutStr(str);
	pceFontSetPos(x    , y + 1); pceFontPutStr(str);
	pceFontSetTxColor(incol);
	pceFontSetPos(x    , y    ); pceFontPutStr(str);
}

/****************************************************************************
 *	timestr
 ****************************************************************************/

void
timestr(char* str/*9oCgȏ*/, int time)
{
	int hh, mm, ss;

	ss = time / FPS;
	mm = ss / 60; ss %= 60;
	hh = mm / 60; mm %= 60;
	if(hh > 99) { hh = 99; mm = 59; ss = 59; }
	sprintf(str, "%02d:%02d:%02d", hh, mm, ss);
}

/****************************************************************************
 *	card_disp
 ****************************************************************************/

/* J[h\܂B
 * [in]
 *	x,y	\ʒu̍W
 *	card	J[hCfbNX
 *	sel	0:ʏ/1:I
 */
void
card_disp(int x, int y, unsigned char card, int sel)
{
	int sx, sy;
	unsigned char back;

	/* I͔̒wi */
	if(card == CARD_NUL && !sel) goto L10;

	/* wi\B */
	back = sel ? CARD_SELECT : CARD_NORMAL;
	sy = CARD_MARK(back) * 24;
	sx = CARD_NO(back) * 16;
	draw_object(&pat, x, y, sx, sy, 15, 23, DRW_NOMAL);
L10:
	/* Oi\B */
	sy = CARD_MARK(card) * 24;
	sx = CARD_NO(card) * 16;
	draw_object(&pat, x, y, sx, sy, 15, 23, DRW_NOMAL);
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int src, dst, col, row, x, y, sel, x1, y1, x2, y2;
	unsigned char card;
	char str[32];

	draw_object(&bg, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);

	/* KChEXN[pB */
	x1 = y1 = x2 = y2 = 0;
	gi.bottom = DISP_Y;

	/* ړEړoĂB */
	if(gi.n_sel != 0) {
		src = gi.sel[gi.i_sel].src;
		dst = gi.sel[gi.i_sel].dst[gi.sel[gi.i_sel].i_dst];
	} else {
		src = -1;
		dst = -1;
	}

	/* RD() */
	x = 8;
	y = 1;
	if(gi.n_yama_fuse == 0) {
		card = CARD_NUL;
	} else {
		card = CARD_REV;
	}
	sel = 0;
	if(SEL_TYPE(src) == SEL_YAMA_FUSE) { sel = 1; x1 = x; y1 = y; }
	if(SEL_TYPE(dst) == SEL_YAMA_FUSE) { sel = 1; x2 = x; y2 = y; }
	card_disp(x, y - gi.top, card, sel);
	if(y + 24 > gi.bottom) gi.bottom = y + 24;

	/* RD(J) */
	x = 8 + 16;
	y = 1;
	for(col = 0; col < gi.n_yama_hira; col++) {
		card = gi.yama_hira[col];
		sel = 0;
		if(SEL_TYPE(src) == SEL_YAMA_HIRA &&
		   col == gi.n_yama_hira - 1) { sel = 1; x1 = x; y1 = y; }
		if(SEL_TYPE(dst) == SEL_YAMA_HIRA &&
		   col == gi.n_yama_hira - 1) { sel = 1; x2 = x; y2 = y; }
		card_disp(x, y - gi.top, card, sel);
		if(y + 24 > gi.bottom) gi.bottom = y + 24;
		x += 8;
	}

	/* gD */
	x = 8 + 16 * 3;
	y = 1;
	for(col = 0; col < 4; col++) {
		if(gi.n_kumi[col] == 0) {
			card = CARD_NUL;
		} else {
			card = gi.kumi[col][gi.n_kumi[col] - 1];
		}
		sel = 0;
		if(SEL_TYPE(src) == SEL_KUMI &&
		   SEL_COL(src) == col) { sel = 1; x1 = x; y1 = y; }
		if(SEL_TYPE(dst) == SEL_KUMI &&
		   SEL_COL(dst) == col) { sel = 1; x2 = x; y2 = y; }
		card_disp(x, y - gi.top, card, sel);
		if(y + 24 > gi.bottom) gi.bottom = y + 24;
		x += 16;
	}

	/* D */
	x = 8;
	for(col = 0; col < 7; col++) {
		y = 1 + 24;
		if(gi.n_ba[col] == 0) {
			card = CARD_NUL;
			sel = 0;
			if(SEL_TYPE(src) == SEL_BA &&
			   SEL_COL(src) == col) { sel = 1; x1 = x; y1 = y; }
			if(SEL_TYPE(dst) == SEL_BA &&
			   SEL_COL(dst) == col) { sel = 1; x2 = x; y2 = y; }
			card_disp(x, y - gi.top, card, sel);
			if(y + 24 > gi.bottom) gi.bottom = y + 24;
		} else {
			for(row = 0; row < gi.n_ba[col]; row++) {
				card = row < gi.n_ba_fuse[col] ? CARD_REV : gi.ba[col][row];
				sel = 0;
				if(SEL_TYPE(src) == SEL_BA &&
				   SEL_COL(src) == col &&
				   SEL_ROW(src) == row) { sel = 1; x1 = x; y1 = y; }
				if(SEL_TYPE(dst) == SEL_BA &&
				   SEL_COL(dst) == col &&
				   SEL_ROW(dst) == row) { sel = 1; x2 = x; y2 = y; }
				card_disp(x, y - gi.top, card, sel);
				if(y + 24 > gi.bottom) gi.bottom = y + 24;
				y += row < gi.n_ba_fuse[col] ? 2 : 8;
			}
		}
		x += 16;
	}

	if(gi.n_sel != 0) {
		/* KCh */
		if(x1 != x2 || y1 != y2) {
			y1 -= gi.top;
			y2 -= gi.top;
			render_dashes(&render, x1     , y1     , x2     , y2     , ~(now / 2), dashes, sizeof dashes);
			render_dashes(&render, x1 + 14, y1     , x2 + 14, y2     , ~(now / 2), dashes, sizeof dashes);
			render_dashes(&render, x1     , y1 + 22, x2     , y2 + 22, ~(now / 2), dashes, sizeof dashes);
			render_dashes(&render, x1 + 14, y1 + 22, x2 + 14, y2 + 22, ~(now / 2), dashes, sizeof dashes);
		} else {
			x = x1;
			y = y1 - gi.top;
			x++; render_dashes(&render, x, y, x + 13, y, now / 2, dashes, sizeof dashes); x += 13;
			y++; render_dashes(&render, x, y, x, y + 21, now / 2, dashes, sizeof dashes); y += 21;
			x--; render_dashes(&render, x, y, x - 13, y, now / 2, dashes, sizeof dashes); x -= 13;
			y--; render_dashes(&render, x, y, x, y - 21, now / 2, dashes, sizeof dashes); y -= 21;
		}

		/* I */
		x = 104;
		y = 104;
		if(gi.n_sel > 1) {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				x += 16 * 3;	/* ㉺E */
			} else {
				x += 16 * 2;	/* E */
			}
		} else {
			if(gi.sel[gi.i_sel].n_dst > 1) {
				x += 16 * 1;	/* ㉺ */
			}
		}
		draw_object(&pat, 0, DISP_Y - 13, x, y, 13, 13, DRW_NOMAL);
	}

	/* XN[ */
	if(joy & PAD_B) {
		gi.top += 4;
	} else {
		gi.top -= 4;
	}
	if(gi.top < 0) gi.top = 0;
	if(gi.top > gi.bottom - DISP_Y) gi.top = gi.bottom - DISP_Y;
	if(gi.top == 0 && gi.top < gi.bottom - DISP_Y) {
		draw_object(&pat, DISP_X - 7, DISP_Y - 12, 168, 104, 7, 12, DRW_NOMAL);
	}

	/* oߎ */
	pceFontSetType(0x82);
	timestr(str, gi.time);
	x = (DISP_X - 4 * 8) / 2;
	y = DISP_Y - 6;
	stredge(x, y, str, 3, 0);
}

/****************************************************************************
 *	find_sel
 ****************************************************************************/

/* ړƈړ̑gݍ킹ɂDxBقǗDx
 *	0	RD(J) -> gD
 *	1	D       -> gD
 *	2	RD(J) -> D
 *	3	DI[v		... vOŔ
 *	4	RD()I[v
 *	5	D       -> D	... vOŔ
 *	6	gD       -> D
 */
static const int prior[4][4] = {
    /*dst=       FUSE HIRA  BA  KUMI*/
    /*src=FUSE*/{   4,  -1,  -1,  -1},
    /*    HIRA*/{  -1,  -1,   2,   0},
    /*     BA */{  -1,  -1,9999,   1},
    /*    KUMI*/{  -1,  -1,   6,  -1},
};

static int
comp_sel(const void* _a, const void* _b)
{
	SEL* a = (SEL*)_a;
	SEL* b = (SEL*)_b;
	int a_prior = prior[SEL_TYPE(a->src)][SEL_TYPE(a->dst[0])];
	int b_prior = prior[SEL_TYPE(b->src)][SEL_TYPE(b->dst[0])];
	if(a_prior == 9999) {
		if(a->src == a->dst[0]) {
			a_prior = 3;	/* DI[v */
		} else {
			a_prior = 5;	/* D -> D */
		}
	}
	if(b_prior == 9999) {
		if(b->src == b->dst[0]) {
			b_prior = 3;	/* DI[v */
		} else {
			b_prior = 5;	/* D -> D */
		}
	}
	if(a_prior == b_prior) {	/* DxȂʒuقǗDƂ */
		a_prior = ((a->src & 0xffff) << 16) | (a->dst[0] & 0xffff);
		b_prior = ((b->src & 0xffff) << 16) | (b->dst[0] & 0xffff);
	}
	return a_prior - b_prior;
}

int
find_sel(SEL sel[52])
{
	int n_sel, col, row;

	n_sel = 0;

	/***** RD() *****/
	/* RD(EJE)ꖇł΁AJ܂B */
	if(gi.n_yama_fuse != 0 ||
	   gi.n_yama_hira != 0 ||
	   gi.n_yama_naga != 0) {
		sel[n_sel].src = SEL_MAKE(SEL_YAMA_FUSE, -1, -1);
		sel[n_sel].n_dst = find_dst(sel[n_sel].src, sel[n_sel].dst);
		if(sel[n_sel].n_dst != 0) { sel[n_sel++].i_dst = 0; }
	}

	/***** RD(J) *****/
	/* RD(J)ꖇł΁Aԏ̃J[hړł܂B */
	if(gi.n_yama_hira != 0) {
		sel[n_sel].src = SEL_MAKE(SEL_YAMA_HIRA, -1, -1);
		sel[n_sel].n_dst = find_dst(sel[n_sel].src, sel[n_sel].dst);
		if(sel[n_sel].n_dst != 0) { sel[n_sel++].i_dst = 0; }
	}

	/***** D *****/
	/* eɂ... */
	for(col = 0; col < 7; col++) {
		/*  ꖇȂΔ΂܂B */
		if(gi.n_ba[col] == 0) continue;
		if(gi.n_ba[col] == gi.n_ba_fuse[col]) {
			/* ԏオĂAJ܂B */
			row = gi.n_ba_fuse[col] - 1;
			sel[n_sel].src = SEL_MAKE(SEL_BA, col, row);
			sel[n_sel].n_dst = find_dst(sel[n_sel].src, sel[n_sel].dst);
			if(sel[n_sel].n_dst != 0) { sel[n_sel++].i_dst = 0; }
		} else {
			/* ԏオJĂAړł܂Bi܂Ƃ߂Ăj */
			for(row = gi.n_ba[col] - 1; row >= gi.n_ba_fuse[col]; row--) {
				sel[n_sel].src = SEL_MAKE(SEL_BA, col, row);
				sel[n_sel].n_dst = find_dst(sel[n_sel].src, sel[n_sel].dst);
				if(sel[n_sel].n_dst != 0) { sel[n_sel++].i_dst = 0; }
			}
		}
	}

	/***** gD *****/
	/* eɂ... */
	for(col = 0; col < 4; col++) {
		/*  ꖇȂΔ΂܂B */
		if(gi.n_kumi[col] == 0) continue;
		/* ԏ̃J[hړł܂B */
		sel[n_sel].src = SEL_MAKE(SEL_KUMI, col, -1);
		sel[n_sel].n_dst = find_dst(sel[n_sel].src, sel[n_sel].dst);
		if(sel[n_sel].n_dst != 0) { sel[n_sel++].i_dst = 0; }
	}

	qsort(sel, n_sel, sizeof(SEL), comp_sel);

	return n_sel;
}

/****************************************************************************
 *	find_dst
 ****************************************************************************/

int
find_dst(int src, int dst[52])
{
	int n_dst, col, row, sel;
	int src_type, src_col, src_row;
	int src_card, src_mark, src_no;
	int dst_card, dst_mark, dst_no;

	n_dst = 0;

	/* ړ̔菇ŗDx܂܂ */

	/* ړ擾܂BiJ[h͂܂łj */
	src_type = SEL_TYPE(src);
	src_col = SEL_COL(src);
	src_row = SEL_ROW(src);

	/* ړɂ... */
	switch(src_type) {
	/***** ړ=RD() *****/
	case SEL_YAMA_FUSE:
		/* ŊJ܂B */
		dst[n_dst++] = src;
		break;

	/***** ړ=RD(J) *****/
	case SEL_YAMA_HIRA:
		/* ړJ[h擾B */
		src_card = gi.yama_hira[gi.n_yama_hira - 1];
		src_mark = CARD_MARK(src_card);
		src_no = CARD_NO(src_card);
		/***** ړ=gD *****/
		for(col = 0; col < 4; col++) {
			if(gi.n_kumi[col] == 0) {
				/* ɂ́AK}[ÑG[X݈̂ړł܂B */
				if(src_mark == col && src_no == (1 - 1)) {
					sel = SEL_MAKE(SEL_KUMI, col, -1);
					dst[n_dst++] = sel;
				}
			} else {
				/* K}[N̏ňړł܂B */
				row = gi.n_kumi[col] - 1;
				dst_card = gi.kumi[col][row];
				dst_mark = CARD_MARK(dst_card);
				dst_no = CARD_NO(dst_card);
				if(src_mark == col && src_no == dst_no + 1) {
					sel = SEL_MAKE(SEL_KUMI, col, row);
					dst[n_dst++] = sel;
				}
			}
		}
		/***** ړ=D *****/
		for(col = 0; col < 7; col++) {
			if(gi.n_ba[col] == 0) {
				/* ɂ̓LÔ݈ړł܂B */
				if(src_no == (13 - 1)) {
					sel = SEL_MAKE(SEL_BA, col, -1);
					dst[n_dst++] = sel;
				}
			} else if(gi.n_ba[col] > gi.n_ba_fuse[col]) { /* JJ[h̏ɂ݈̂ړ\ */
				/* FႢ̍~ňړł܂B */
				row = gi.n_ba[col] - 1;
				dst_card = gi.ba[col][row];
				dst_mark = CARD_MARK(dst_card);
				dst_no = CARD_NO(dst_card);
				if((src_mark ^ dst_mark) & 1 && src_no == dst_no - 1) {
					sel = SEL_MAKE(SEL_BA, col, row);
					dst[n_dst++] = sel;
				}
			}
		}
		break;

	/***** ړ=D *****/
	case SEL_BA:
		/* ړJ[h擾B */
		src_card = gi.ba[src_col][src_row];
		src_mark = CARD_MARK(src_card);
		src_no = CARD_NO(src_card);
		if(gi.n_ba[src_col] == gi.n_ba_fuse[src_col]) {
			/* ԏオĂAŊJ܂B */
			dst[n_dst++] = src;
		} else {
			/***** ړ=gD *****/
			if(src_row == gi.n_ba[src_col] - 1) { /* PƑÎ݈ړ\ */
				for(col = 0; col < 4; col++) {
					if(gi.n_kumi[col] == 0) {
						/* ɂ́AK}[ÑG[X݈̂ړł܂B */
						if(src_mark == col && src_no == (1 - 1)) {
							sel = SEL_MAKE(SEL_KUMI, col, -1);
							dst[n_dst++] = sel;
						}
					} else {
						/* K}[N̏ňړł܂B */
						row = gi.n_kumi[col] - 1;
						dst_card = gi.kumi[col][row];
						dst_mark = CARD_MARK(dst_card);
						dst_no = CARD_NO(dst_card);
						if(src_mark == col && src_no == dst_no + 1) {
							sel = SEL_MAKE(SEL_KUMI, col, row);
							dst[n_dst++] = sel;
						}
					}
				}
			}
			/***** ړ=D *****/
			for(col = 0; col < 7; col++) {
				if(col == src_col) continue; /* Ȃ΂܂ */
				if(gi.n_ba[col] == 0) {
					/* ɂ̓LÔ݈ړł܂B */
					if(src_no == (13 - 1)) {
						sel = SEL_MAKE(SEL_BA, col, -1);
						dst[n_dst++] = sel;
					}
				} else if(gi.n_ba[col] > gi.n_ba_fuse[col]) { /* JJ[h̏ɂ݈̂ړ\ */
					/* FႢ̍~ňړł܂B */
					row = gi.n_ba[col] - 1;
					dst_card = gi.ba[col][row];
					dst_mark = CARD_MARK(dst_card);
					dst_no = CARD_NO(dst_card);
					if((src_mark ^ dst_mark) & 1 && src_no == dst_no - 1) {
						sel = SEL_MAKE(SEL_BA, col, row);
						dst[n_dst++] = sel;
					}
				}
			}
		}
		break;

	/***** ړ=gD *****/
	case SEL_KUMI:
		/* ړJ[h擾B */
		src_card = gi.kumi[src_col][gi.n_kumi[src_col] - 1];
		src_mark = CARD_MARK(src_card);
		src_no = CARD_NO(src_card);
		/***** ړ=D *****/
		for(col = 0; col < 7; col++) {
			if(gi.n_ba[col] == 0) {
				/* ɂ̓LÔ݈ړł܂B */
				if(src_no == (13 - 1)) {
					sel = SEL_MAKE(SEL_BA, col, -1);
					dst[n_dst++] = sel;
				}
			} else if(gi.n_ba[col] > gi.n_ba_fuse[col]) { /* JJ[h̏ɂ݈̂ړ\ */
				/* FႢ̍~ňړł܂B */
				row = gi.n_ba[col] - 1;
				dst_card = gi.ba[col][row];
				dst_mark = CARD_MARK(dst_card);
				dst_no = CARD_NO(dst_card);
				if((src_mark ^ dst_mark) & 1 && src_no == dst_no - 1) {
					sel = SEL_MAKE(SEL_BA, col, row);
					dst[n_dst++] = sel;
				}
			}
		}
		break;
	}

	return n_dst;
}

/****************************************************************************
 *	do_move
 ****************************************************************************/

void
do_move(int src, int dst)
{
	int src_type, src_col, src_row;
	int dst_type, dst_col, dst_row;
	unsigned char tmp[52];
	int i, n_tmp;

	n_tmp = 0;

	/* ړ擾܂BiJ[h͂܂łj */
	src_type = SEL_TYPE(src);
	src_col = SEL_COL(src);
	src_row = SEL_ROW(src);

	/* ړ擾܂BiJ[h͂܂łj */
	dst_type = SEL_TYPE(dst);
	dst_col = SEL_COL(dst);
	dst_row = SEL_ROW(dst);

	/* ړɂ... */
	switch(src_type) {
	/***** ړ=RD() *****/
	case SEL_YAMA_FUSE:
		/* RD(J)RD()ցB */
		while(gi.n_yama_hira != 0) {
			gi.yama_naga[gi.n_yama_naga++] = gi.yama_hira[--gi.n_yama_hira];
		}
		if(gi.n_yama_fuse == 0) {
			/* RD()ȂȂARD()߂B */
			for(i = 0; i < gi.n_yama_naga; i++) gi.yama_fuse[i] = gi.yama_naga[i];
			gi.n_yama_fuse = gi.n_yama_naga;
			gi.n_yama_naga = 0;
		} else {
			/* RD()RD(J)ցB */
			while(gi.n_yama_fuse != 0 && gi.n_yama_hira < 3) {
				gi.yama_hira[gi.n_yama_hira++] = gi.yama_fuse[--gi.n_yama_fuse];
			}
		}
		return; /* ړ܂ */

	/***** ړ=RD(J) *****/
	case SEL_YAMA_HIRA:
		/* ړJ[hꎞobt@ցB */
		tmp[n_tmp++] = gi.yama_hira[--gi.n_yama_hira];
		break;

	/***** ړ=D *****/
	case SEL_BA:
		if(gi.n_ba[src_col] == gi.n_ba_fuse[src_col]) {
			/* ԏJB */
			gi.n_ba_fuse[src_col]--;
			return; /* ړ܂ */
		} else {
			/* ړJ[hꎞobt@ցB */
			for(i = src_row; i < gi.n_ba[src_col]; i++) tmp[n_tmp++] = gi.ba[src_col][i];
			gi.n_ba[src_col] = src_row;
		}
		break;

	/***** ړ=gD *****/
	case SEL_KUMI:
		/* ړJ[hꎞobt@ցB */
		tmp[n_tmp++] = gi.kumi[src_col][--gi.n_kumi[src_col]];
		break;
	}

	/* ړɂ... */
	switch(dst_type) {
	/***** ړ=D *****/
	case SEL_BA:
		for(i = 0; i < n_tmp; i++) gi.ba[dst_col][gi.n_ba[dst_col]++] = tmp[i];
		break;

	/***** ړ=gD *****/
	case SEL_KUMI:
		for(i = 0; i < n_tmp; i++) gi.kumi[dst_col][gi.n_kumi[dst_col]++] = tmp[i];
		break;
	}
}
